.retry: &retry
  retry:
    max: 2
    when: script_failure

.build-docker-images: &build-docker-images
  <<: *retry
  stage: build
  image: docker:24.0.2-git
  needs: []
  services:
    - docker:24.0.2-dind
  variables:
    DOCKER_BUILDKIT: 1
    BUILDKIT_INLINE_CACHE: 1
    DOCKER_TLS_CERTDIR: "/certs"
    CYPRESS_INSTALL_BINARY: "0"
  script:
    - if [ "$NAME" == "mesh" ]; then cd mesh; sh copy-protos.sh; cd -;fi;
    - export DOCKER_CONFIG=/tmp/docker-config-$CI_JOB_ID
    - mkdir -p $DOCKER_CONFIG && echo $DOCKER_AUTH_CONFIG > $DOCKER_CONFIG/config.json
    - echo "$CI_REGISTRY_PASSWORD" | docker login $CI_REGISTRY --username $CI_REGISTRY_USER --password-stdin
    - docker build --build-arg BUILDKIT_INLINE_CACHE=$BUILDKIT_INLINE_CACHE --cache-from $CI_REGISTRY_IMAGE/$NAME:$CI_COMMIT_REF_SLUG -t $CI_REGISTRY_IMAGE/$NAME:$IMAGE_TAG -t $CI_REGISTRY_IMAGE/$NAME:$CI_COMMIT_REF_SLUG $DOCKERATTRIBUTES
    - docker push $CI_REGISTRY_IMAGE/$NAME:$CI_COMMIT_REF_SLUG
    - docker push $CI_REGISTRY_IMAGE/$NAME:$IMAGE_TAG
  parallel:
    matrix:
      - NAME: mesh
        DOCKERATTRIBUTES: "--file=./mesh/Dockerfile ./mesh"
      - NAME: frontend
        DOCKERATTRIBUTES: "./frontend"
      - NAME: backend
        DOCKERATTRIBUTES: "./backend"
      - NAME: alarmenservice
        DOCKERATTRIBUTES: "--file=./huishoudboekje_services/AlarmService.Application/Dockerfile ./huishoudboekje_services"
      - NAME: notificationservice
        DOCKERATTRIBUTES: "--file=./huishoudboekje_services/NotificationService.Application/Dockerfile ./huishoudboekje_services"
      - NAME: userapi
        DOCKERATTRIBUTES: "--file=./huishoudboekje_services/UserApi.Application/Dockerfile ./huishoudboekje_services"
      - NAME: authservice
        DOCKERATTRIBUTES: "./services/authservice"
      - NAME: banktransactieservice
        DOCKERATTRIBUTES: "--file=./huishoudboekje_services/BankServices.Application/Dockerfile ./huishoudboekje_services"
      - NAME: grootboekservice
        DOCKERATTRIBUTES: "--file=./services/grootboek_service/Dockerfile services"
      - NAME: huishoudboekjeservice
        DOCKERATTRIBUTES: "--file=./services/huishoudboekje_service/Dockerfile services"
      - NAME: logservice
        DOCKERATTRIBUTES: "--file=./huishoudboekje_services/LogService.Application/Dockerfile ./huishoudboekje_services"
      - NAME: fileservice
        DOCKERATTRIBUTES: "--file=./huishoudboekje_services/FileServices.Application/Dockerfile ./huishoudboekje_services"
      - NAME: partyservice
        DOCKERATTRIBUTES: "--file=./huishoudboekje_services/PartyServices.Application/Dockerfile ./huishoudboekje_services"
      - NAME: hhbservice
        DOCKERATTRIBUTES: "--file=./huishoudboekje_services/HHBServices.Application/Dockerfile ./huishoudboekje_services"
      - NAME: rapportageservice
        DOCKERATTRIBUTES: "--file=./services/rapportage_service/Dockerfile services"
      - NAME: rabbitmq-message-publisher
        DOCKERATTRIBUTES: "./rabbitmq-message-publisher"

build-databasemesh-image:
  stage: build
  image: docker:24.0.2-git
  needs: []
  services:
    - docker:24.0.2-dind
  variables:
    DOCKER_BUILDKIT: 1
    BUILDKIT_INLINE_CACHE: 1
    DOCKER_TLS_CERTDIR: "/certs"
    CYPRESS_INSTALL_BINARY: "0"
  script:
    - if [ "$NAME" == "mesh" ]; then cd mesh; sh copy-protos.sh; cd -;fi;
    - export DOCKER_CONFIG=/tmp/docker-config-$CI_JOB_ID
    - mkdir -p $DOCKER_CONFIG && echo $DOCKER_AUTH_CONFIG > $DOCKER_CONFIG/config.json
    - echo "$CI_REGISTRY_PASSWORD" | docker login $CI_REGISTRY --username $CI_REGISTRY_USER --password-stdin
    - docker build --build-arg BUILDKIT_INLINE_CACHE=$BUILDKIT_INLINE_CACHE --cache-from $CI_REGISTRY_IMAGE/databasemesh:$CI_COMMIT_REF_SLUG -t $CI_REGISTRY_IMAGE/databasemesh:$IMAGE_TAG -t $CI_REGISTRY_IMAGE/databasemesh:$CI_COMMIT_REF_SLUG --file=./database-mesh/dev.Dockerfile ./database-mesh
    - docker push $CI_REGISTRY_IMAGE/databasemesh:$CI_COMMIT_REF_SLUG
    - docker push $CI_REGISTRY_IMAGE/databasemesh:$IMAGE_TAG
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'

# Build docker images with default tag ("branchName-commitSha").
build-images-dev:
  <<: *build-docker-images
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
    - if: $CI_PIPELINE_SOURCE == "schedule"
    - if: $CI_COMMIT_BRANCH == "develop"

# Build docker images with the name of the tag as the image tag.
build-tagged-images:
  <<: *build-docker-images
  variables:
    IMAGE_TAG: $CI_COMMIT_TAG
  rules:
    - if: $CI_COMMIT_TAG
